package tlass.project;

import tlass.project.model.Assistant;

public class ModelEvent {
	private Object source;
	private Object item;
	private int type;
	
	public static final int ADDED= 0;
	public static final int REMOVED= 1;
	public static final int RENAMED= 2;

	/**
	 * Constructor for ModelEvent. Source is the list of resources that
	 * item is/was/is now a part of, and type is whether this resource
	 * was added, renamed, or removed
	 * @param source
	 * @param item
	 * @param type
	 */
	public ModelEvent(Object source, Object item, int type) {
		this.setSource(source);
		this.item= item;
		this.setType(type);
	}

	/**
	 * Getter for item
	 * @return
	 */
	public Object getItem() {
		return item;
	}

	/**
	 * setter for item
	 * @param item
	 */
	public void setItem(Object item) {
		this.item= item;
	}

	/**
	 * setter for type
	 * @param type
	 */
	public void setType(int type) {
		this.type = type;
	}

	/**
	 * getter for type
	 * @return
	 */
	public int getType() {
		return type;
	}

	/**
	 * setter for source
	 * @param source
	 */
	public void setSource(Object source) {
		this.source = source;
	}

	/**
	 * getter for source
	 * @return
	 */
	public Object getSource() {
		return source;
	}
}
