package tlass.project.constraintTypes;

import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Position;
import tlass.project.model.Section;
import JaCoP.constraints.XneqC;
import JaCoP.core.IntVar;
import JaCoP.core.Store;

public class ForbidAssignmentConstraint extends Constraint{

	/**
	 * Constructor for this constraint.
	 */
	public ForbidAssignmentConstraint() {
		name= "Forbid Assignment";
		description= "Prevents students listed as being forbidden from assisting a course.";
	}

	/**
	 * Forbid Specific Assignment: Forbid an assistant from filling a specific position.
	 */
	@Override
	public void imposeConstraint(Store jacopStore, IntVar[] variables,
			Position[] positions, Assistant[] assistants) {
		for (int i= 0; i < positions.length; i+= 1) {
			IntVar aVariable= variables[i];
			Position aPosition= positions[i];
			Section section= aPosition.getSection();
			for (int j= 0; j < assistants.length; j+= 1) {
				Assistant anAssistant= assistants[j];
				boolean forbidden= section.isForbiddenAssistant(aPosition, anAssistant);
				if (forbidden) {
					jacopStore.impose(new XneqC(aVariable,j));
				}
			}
		}
	}

}
