package tlass.project.constraintTypes;

import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Instructor;
import tlass.project.model.Position;
import tlass.project.model.Section;
import JaCoP.constraints.XneqC;
import JaCoP.core.IntVar;
import JaCoP.core.Store;

public class ForbidInstructorAssignmentConstraint extends Constraint {

	/**
	 * Constructor for this constraint.
	 */
	public ForbidInstructorAssignmentConstraint() {
		name= "Forbid Instructor Assignment";
		description= "";
	}

	/**
	 * Instructor Precludes Assistant: Forbid an assistant from being 
	 * assigned to a section taught by a specific professor.
	 */
	@Override
	public void imposeConstraint(Store jacopStore, IntVar[] variables,
			Position[] positions, Assistant[] assistants) {
		for (int i = 0; i < positions.length; i += 1) {
			IntVar aVariable = variables[i];
			Position aPosition = positions[i];
			Section section = aPosition.getSection();
			Instructor instructor= section.getInstructor();
			for (int j = 0; j < assistants.length; j += 1) {
				Assistant anAssistant = assistants[j];
				boolean forbidden = instructor.isForbiddenAssistant(anAssistant);
				if (forbidden) {
					jacopStore.impose(new XneqC(aVariable, j));
				}
			}
		}
	}

}
