package tlass.project.constraintTypes;

import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Position;
import tlass.project.model.Section;
import JaCoP.constraints.XeqC;
import JaCoP.core.IntVar;
import JaCoP.core.Store;

public class RequireAssignmentConstraint extends Constraint{

	/**
	 * Constructor for this constraint.
	 */
	public RequireAssignmentConstraint() {
		name= "Require Assignment";
		description= "";
	}
	
	/**
	 * Require Specific Assignment: Require a assistant
	 * to fill a specific position.
	 */
	@Override
	public void imposeConstraint(Store jacopStore, IntVar[] variables,
			Position[] positions, Assistant[] assistants) {
		for (int i= 0; i < positions.length; i+= 1) {
			IntVar aVariable= variables[i];
			Position aPosition= positions[i];
			Section section= aPosition.getSection();
			for (int j= 0; j < assistants.length; j+= 1) {
				Assistant anAssistant= assistants[j];
				boolean required= section.isRequiredAssistant(aPosition, anAssistant);
				if (required) {
					jacopStore.impose(new XeqC(aVariable,j));
				}
			}
		}
	}

}
