package tlass.project.gui;

import java.awt.Dimension;
import java.io.IOException;

import javax.swing.BoxLayout;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class HelpWindow extends JPanel{
	private JEditorPane helpPane;
	private JScrollPane helpScrollPane;
	
	//Constructor
	public HelpWindow(){
		this.setOpaque(true);
		
		//setup content holders for in the frame
		setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		
		//create a new pane to hold the text information from helpMenuText.html
		helpPane = new JEditorPane();
		//obtain text from html file and catch exception if can't load
		java.net.URL helpURL = HelpWindow.class.getResource("/resources/helpMenuText.html");
		if (helpURL != null) {
		    try {
		    	helpPane.setPage(helpURL);
		    } catch (IOException e) {
		        System.err.println("Attempted to read a bad URL: " + helpURL);
		    }
		} else {
		    System.err.println("Could not open helpMenuText.html");
		}
		helpPane.setEditable(false);
		
		//put the above pane into a new scrollPane
		helpScrollPane = new JScrollPane(helpPane);
		helpScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		helpScrollPane.setPreferredSize(new Dimension(500, 250));
		helpScrollPane.setMinimumSize(new Dimension(500, 250));
		
		add(helpScrollPane);
	}//end constructor
}
