package tlass.project.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import tlass.project.Controller;


public class LoginMenu extends JMenuBar {
	private static final long serialVersionUID = 1L;
	private JMenu fileMenu;
	private JMenuItem serverSettings;
	private JMenuItem exit;
	private View view;
	
	/**
	 * Create a login menu
	 * 
	 * @param Controller which created the View
	 */
	public LoginMenu(Controller hostController) {
		//get the view from the controller
		this.view = hostController.getView();
		this.setOpaque(true);
		//Build the first menu.
		fileMenu = new JMenu("File");
		fileMenu.setMnemonic(KeyEvent.VK_F);
		fileMenu.getAccessibleContext().setAccessibleDescription("");
		add(fileMenu);
		
		//add server settings button to the menu
		serverSettings = new JMenuItem("ServerSettings");
		serverSettings.setMnemonic(KeyEvent.VK_S);
		fileMenu.add(serverSettings);
		
		// Action for when user presses the server settings button
		serverSettings.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {	
				//close the login window
				view.closeLoginWindow();
				//open the server settings window
				view.openServerSettingsWindow();
			}
		});
	
		//add exit button to the menu
		exit = new JMenuItem("Exit");
		exit.setMnemonic(KeyEvent.VK_E);
		fileMenu.add(exit);
		
		// Action for when presses the exit button
		exit.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {	
				System.exit(0);
			}
		});
	}
}
