/* ResourcePanel.java
 * CISC475 Project
 * Group 02
 */

package tlass.project.gui.panels;

import java.awt.LayoutManager;

import javax.swing.JPanel;

import tlass.project.Controller;
import tlass.project.ModelHandler;
import tlass.project.model.Model;


/**
 * Resource Panel that all other panels in system extend
 */
public class ResourcePanel extends JPanel {
	private static final long serialVersionUID = 1L;
	@SuppressWarnings("unused")
	private Object resource;
	private String leafIcon;
	
	protected Controller controller;
	protected ModelHandler modelHandler;
	protected Model model;
	
	/**
	 * General setup for a resource panel
	 * 
	 * @param Controller where the model handler is
	 * @param LayoutManager of the panel
	 * @param Object of the resource
	 */
	public ResourcePanel(Controller c, LayoutManager layout, Object r) {
		//create a JPanel with the layout as the LayoutManager
		super(layout);
		this.setOpaque(true); //ALWAYS DO THIS FOR JPANEL
		//set the resource as the given object
		this.resource= r;
		//keep track of the controller
		this.controller= c;
		//get the model handler from the controller
		this.modelHandler= c.getModelHandler();
		//get the model from the controller
		this.model= c.getModel();
	}
	/**
	 * 
	 */
	public void refreshPanel() {
		// Do nothing by default.
	}
	/**
	 * set the leaf icon to the input string
	 * @param String of filename with path if needed
	 */
	public void setLeafIcon(String string) {
		this.leafIcon = string;
	}
	/**
	 * get the leaf icon of the resource panel
	 * @return String of the leaf icon
	 */
	public String getLeafIcon() {
		return leafIcon;
	}
}
