/* Constraint.java
 * CISC475 Project
 * Group 02
 */

package tlass.project.model;

import java.io.Serializable;

import JaCoP.core.*;

public abstract class Constraint implements Serializable {
	
	//variables for new system design
	private boolean enabled;
	protected String name;
	protected String description;

	/**
	 * The important function to override for a Constraint. This handles the
	 * jacop logic. It's important to be calling jacopStore.impose(...) somewhere
	 * inside, or you're not actually doing anything.
	 * @param jacopStore
	 * @param variables
	 * @param positions
	 * @param assistants
	 */
	public abstract void imposeConstraint(Store jacopStore, IntVar[] variables, 
										Position[] positions, Assistant[] assistants);

	/**
	 * Simple constructor
	 */
	public Constraint() {
		enabled= true;
	}

	/**
	 * Enabeled setter
	 * @param enabled
	 */
	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}

	/**
	 * Enabled getter
	 * @return
	 */
	public boolean isEnabled() {
		return enabled;
	}

	/**
	 * Returns the name of this constraint, usually changed in the subclass
	 */
	public String toString() {
		return name;
	}

	/**
	 * Name setter
	 * @param name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Name getter
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * Description setter
	 * @param description
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Description getter
	 * @return
	 */
	public String getDescription() {
		return description;
	}
}
