package tlass.unitTesting.constraintTypes;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Scheduler;
import tlass.project.constraintTypes.ForbidAssignmentConstraint;
import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Model;
import tlass.project.model.Position;
import tlass.project.model.Schedule;
import tlass.project.model.Section;

import junit.framework.TestCase;

public class TestForbidAssignmentConstraint {
	
	Scheduler scheduler;
	private Model model;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		scheduler= new Scheduler();
		model= new Model();
	}
	
	@Test
	public void constraintTest() {
		Constraint o= new ForbidAssignmentConstraint();
		Assistant a= new Assistant();
		Section s= new Section();
		Position p= s.addTAPosition();
		s.addForbiddenAssistant(p, a);
		model.addAssistant(a);
		model.addSection(s);
		model.addConstraint(o);
		Schedule c= scheduler.pick(model);
		assertNull("A schedule was generated",c);
		model.addAssistant(new Assistant());
		c= scheduler.pick(model);
		assertNotNull("A schedule was not generated",c);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}


}