package tlass.unitTesting.constraintTypes;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.fail;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Scheduler;
import tlass.project.constraintTypes.ForbidAssignmentConstraint;
import tlass.project.constraintTypes.ForbidInstructorAssignmentConstraint;
import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Instructor;
import tlass.project.model.Model;
import tlass.project.model.Position;
import tlass.project.model.Schedule;
import tlass.project.model.Section;

import junit.framework.TestCase;


public class TestForbidInstructorAssignementConstraint {
	
	Scheduler scheduler;
	private Model model;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		scheduler= new Scheduler();
		model= new Model();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void constraintTest() {
		Constraint o= new ForbidInstructorAssignmentConstraint();
		Assistant a= new Assistant();
		a.setUsername("#1");
		Section s= new Section();
		Position p= s.addTAPosition();
		Instructor i= new Instructor();
		s.setInstructor(i);
		i.addForbiddenAssistant(a);
		model.addAssistant(a);
		model.addSection(s);
		model.addInstructor(i);
		model.addConstraint(o);
		Schedule c= scheduler.pick(model);
		assertNull("A schedule was generated",c);
		Assistant a2= new Assistant();
		model.addAssistant(a2);
		a2.setUsername("#2");
		c= scheduler.pick(model);
		assertNotNull("A schedule was not generated",c);
	}


}