package tlass.unitTesting.constraintTypes;

import static org.junit.Assert.*;
import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Scheduler;
import tlass.project.constraintTypes.ForbidAssignmentConstraint;
import tlass.project.constraintTypes.LimitStudentTotalConstraint;
import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Model;
import tlass.project.model.Position;
import tlass.project.model.Schedule;
import tlass.project.model.Section;

public class TestLimitStudentTotalConstraint {
	
	Scheduler scheduler;
	private Model model;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		scheduler= new Scheduler();
		model= new Model();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void constraintTest() {
		Constraint o= new LimitStudentTotalConstraint();
		Assistant a= new Assistant();
		a.setStudentsLimit(40);
		Section s= new Section();
		s.setEnrolled(30);
		Position p= s.addTAPosition();
		Position p2= s.addTAPosition();
		Section s2= new Section();
		s2.setEnrolled(30);
		model.addAssistant(a);
		model.addSection(s);
		model.addSection(s2);
		model.addConstraint(o);
		Schedule c= scheduler.pick(model);
		//assertNotNull("A schedule was generated",c);
		model.addAssistant(new Assistant());
		c= scheduler.pick(model);
		assertNotNull("A schedule was not generated",c);
	}


}