package tlass.unitTesting.gui;

import static org.junit.Assert.*;

import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JTextArea;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.Pair;
import tlass.project.gui.AuditDialog;
import tlass.project.model.TimeBlock;

public class TestAuditDialog {
	private AuditDialog ad;
	private static JFrame jf;
	private static Controller c;
	private static ArrayList<Pair<String, TimeBlock>> al;

	/**
	 * create the JFrame, Controller, and ArrayList for the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		jf = new JFrame();
		c = new Controller();
		Pair<String, TimeBlock> p1 = new Pair<String, TimeBlock>("",new TimeBlock(TimeBlock.MONDAY, 0, 2, 0, 3));
		Pair<String, TimeBlock> p2 = new Pair<String, TimeBlock>("",new TimeBlock(TimeBlock.TUESDAY, 0, 9, 0, 11));
		al = new ArrayList<Pair<String, TimeBlock>>();
		al.add(p1);
		al.add(p2);
	}

	/**
	 * null the JFrame, Controller, and ArrayList created for the class
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		jf = null;
		c = null;
		al = null;
	}

	/**
	 * create an AuditDialog for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		ad = new AuditDialog(jf,c,al);
	}

	/**
	 * null the AuditDialog created for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		ad = null;
	}

	/**
	 * test the make Lable Style function to make sure that the JTextArea inputted is the same as outputted
	 */
	@Test
	public void makeLabelStyleTest() {
		JTextArea jta = new JTextArea("test");
		assertSame("The text area should be the same, just look different",jta,AuditDialog.makeLabelStyle(jta));
	}

}