package tlass.unitTesting.gui;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.LoginMenu;

/**
 * 
 * @author Michael Chinn
 *
 */
public class TestLoginMenu {
	private static Controller controller;
	private LoginMenu loginMenu;

	/**
	 * Create a controller for use in the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		controller = new Controller();
	}

	/**
	 * null the controller after the class
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		controller = null;
	}

	/**
	 * create a login menu for testing
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		loginMenu = new LoginMenu(controller);
	}

	/**
	 * null the login menu after each test
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		loginMenu = null;
	}

	
	/**
	 * Test componentCount of loginMenu to make sure that there is one component added
	 */
	@Test
	public void componentCountTest() {
		assertEquals("Number of components in login menu is not 1",1,loginMenu.getComponentCount());
	}

}