package tlass.unitTesting.gui;

import static org.junit.Assert.*;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.MainWindow;

public class TestMainWindow {
	static Controller c;
	MainWindow mw;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		mw = new MainWindow(c);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void constructorTest() {
		assertEquals("Main Window does not have 2 components",2,mw.getComponentCount());
	}
	
	@Test
	public void getTreeModelTest() {
		assertEquals("we are actually getting a tree model class",DefaultTreeModel.class,mw.getTreeModel().getClass());
	}
	
	@Test
	public void setTreeModelTest() {
		DefaultTreeModel dtm = new DefaultTreeModel(new DefaultMutableTreeNode("test"));
		mw.setTreeModel(dtm);
		assertSame("the default tree model was set correctly",dtm,mw.getTreeModel());
	}
	
	@Test
	public void setGetTreeTest() {
		JTree jt = new JTree();
		mw.setTree(jt);
		assertSame("the default tree was set and gotten correctly",jt,mw.getTree());
	}
	
	@Test
	public void getControllerTest() {
		assertSame("the controller was gotten correctly",c,mw.getController());
	}
}