package tlass.unitTesting.gui;

import static org.junit.Assert.*;

import javax.swing.JFrame;

import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.SemesterWindow;
import tlass.project.gui.View;

public class TestSemesterWindow {
	private SemesterWindow sw;
	private static View v;
	private static JFrame jf;
	private static Controller c;

	/**
	 * create the controller, view and jframe for the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
		v = new View(c);
		jf = new JFrame("test");
	}

	/**
	 * null the controller, view and jframe after the class
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		c = null;
		v = null;
		jf = null;
	}

	/**
	 * create the semester window for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		sw = new SemesterWindow(v,jf,c);
	}

	/**
	 * null the semester window after each test
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		sw = null;
	}

	/**
	 * test the Semster Window Contstructor
	 */
	@Test
	public void semesterWindowtest() {
		assertEquals("There should be 5 private components in the SemesterWindow",5,sw.getComponentCount());
	}

}