package tlass.unitTesting.gui;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.gui.SpecialComboBoxModel;

/**
 * 
 * @author Michael Chinn
 *
 */
public class TestSpecialComboBoxModel {
	SpecialComboBoxModel scbm;
	static String s;

	/**
	 * create a string for use in the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		s = new String("test");
	}

	/**
	 * null the string after all the tests
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		s = null;
	}

	/**
	 * create a new specialComboBoxModel for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		scbm = new SpecialComboBoxModel();
	}

	/**
	 * null the specialComboBoxModel after each test
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		scbm = null;
	}

	/**
	 * make sure that contains works correctly
	 */
	@SuppressWarnings("unchecked")
	@Test
	public void containsTest() {
		scbm.addElement(s);
		assertTrue("Special Combo Box Model Does not contain string 'test'",scbm.contains(s));
		assertFalse("Special Combo Box Model contains string 'fail'",scbm.contains(new String("fail")));
	}

}