package tlass.unitTesting.gui;

import static org.junit.Assert.*;

import javax.swing.JFrame;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.View;

/**
 * 
 * @author mechinn
 *
 */
public class TestView {
	private static Controller c;
	private static JFrame jf;
	@SuppressWarnings("unused")
	private View v;

	/**
	 * create a controller and JFrame for the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
		jf = new JFrame();
	}

	/**
	 * null the controller and JFrame after the class
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		c = null;
		jf = null;
	}

	/**
	 * create a View for the tests
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		v = new View(c);
	}

	/**
	 * null the view after the tests
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		v = null;
	}

	/**
	 * check if we can get the frame from the view
	 */
	@Test
	public void getFrameTest() {
		assertEquals("The view's frame is not a JFrame",JFrame.class,View.getFrame().getClass());
		assertEquals("be sure the frame was set correctly","Teaching and Lab Assistant Scheduling System",View.getFrame().getTitle());
	}
	
	/**
	 * check if we can set the frame from the view
	 */
	@Test
	public void setFrameTest() {
		View.setFrame(jf);
		assertEquals("The view's frame is not a JFrame",jf,View.getFrame());
		assertEquals("be sure the frame was set correctly","",View.getFrame().getTitle());
	}
}