package tlass.unitTesting.gui.panels;

import static org.junit.Assert.*;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.MainWindow;
import tlass.project.gui.panels.InstructorPanel;
import tlass.project.model.Instructor;

public class TestInstructorPanel {
	private InstructorPanel ip;
	private static Controller c;
	private static Instructor i;
	private static JTree jt;
	private static DefaultMutableTreeNode dmtn;
	private static MainWindow mw;

	/**
	 * create a controller, instructor, jtree, defaultmutabletreenode and mainwindow for the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
		i = new Instructor();
		jt = new JTree();
		dmtn = new DefaultMutableTreeNode();
		mw = new MainWindow(c);
	}

	/**
	 * null a controller, instructor, jtree, defaultmutabletreenode and mainwindow for the class
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		c = null;
		i = null;
		jt = null;
		dmtn = null;
		mw = null;
	}

	/**
	 * create an instructor panel for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		ip = new InstructorPanel(c,i,jt,dmtn,mw);
	}

	/**
	 * null the instructor panel after each test
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		ip = null;
	}

	/**
	 * test getting the instructor from the panel
	 */
	@Test
	public void getInstructorTest() {
		assertEquals("The Instructor panel is instructor i",i,ip.getInstructor());
	}
	
	/**
	 * test setting the instructor of the panel
	 */
	@Test
	public void setInstructorTest() {
		Instructor newI = new Instructor();
		assertSame("The Instructor panel is instructor i",i,ip.getInstructor());
		assertNotSame("The Instructor panel is instructor newI",newI,ip.getInstructor());
		ip.setInstructor(newI);
		assertNotSame("The Instructor panel is instructor i",i,ip.getInstructor());
		assertSame("The Instructor panel is instructor newI",newI,ip.getInstructor());
	}
}