package tlass.unitTesting.gui.panels;

import static org.junit.Assert.*;

import java.awt.BorderLayout;
import java.awt.LayoutManager;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.panels.ResourcePanel;
/**
 * 
 * @author Michael Chinn
 *
 */
public class TestResourcePanel {
	private static Controller c;
	private static LayoutManager lm;
	private static String s;
	private ResourcePanel rp;

	/**
	 * Setup the controller, borderlayout and string for everything in the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
		lm = new BorderLayout();
		s = new String("test");
	}

	/**
	 * null controller, layout and string
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		c = null;
		lm = null;
		s = null;
	}

	/**
	 * setup a new resource panel for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		rp = new ResourcePanel(c,lm,s);
	}

	/**
	 * null the resource panel every time we change tests
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		rp = null;
	}

	/**
	 * test to make sure that the layout is being set correctly
	 */
	@Test
	public void superTest() {
		assertEquals("Resource Panel layout is not BorderLayout",lm,rp.getLayout());
	}
	
	/**
	 * test to make sure by default leaf icon is null 
	 */
	@Test
	public void getLeafIconTest() {
		assertNull("Resource Panel layout is not BorderLayout",rp.getLeafIcon());
	}
	
	/**
	 * test to make sure that setting the leaf icon correctly and getting it is the same string
	 */
	@Test
	public void setLeafIconTest() {
		rp.setLeafIcon(s);
		assertEquals("Resource Panel layout is not BorderLayout",s,rp.getLeafIcon());
	}

}