package tlass.unitTesting.gui.panels;

import static org.junit.Assert.*;

import java.awt.BorderLayout;
import java.awt.LayoutManager;

import javax.swing.JFrame;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.panels.ResourcePanel;
import tlass.project.gui.panels.Restriction;
import tlass.project.gui.panels.RestrictionDialog;
import tlass.project.model.Position;
import tlass.project.model.Section;
/**
 * 
 * @author Michael Chinn
 *
 */
public class TestRestrictionDialog {
	private static Controller c;
	private static LayoutManager lm;
	private static String s;
	private static JFrame jf;
	private static Position p;
	private static Restriction r;
	private RestrictionDialog rd;

	/**
	 * Setup the controller, borderlayout and string for everything in the class
	 * 
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
		lm = new BorderLayout();
		s = new String("test");
		jf = new JFrame();
		p = new Position(new Section(),true,1);
	}

	/**
	 * null controller, layout and string
	 * 
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		c = null;
		lm = null;
		s = null;
	}

	/**
	 * setup a new resource panel for each test
	 * 
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		rd = new RestrictionDialog(jf,c,p,Restriction.NONE,s);
	}

	/**
	 * null the resource panel every time we change tests
	 * 
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		rd = null;
	}

	/**
	 * test to make sure that the layout is being set correctly
	 */
	@Test
	public void superTest() {
		assertEquals("Resource Panel layout is BorderLayout",BorderLayout.class,rd.getLayout().getClass());
	}
}