package tlass.unitTesting.gui.panels;

import static org.junit.Assert.*;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Controller;
import tlass.project.gui.MainWindow;
import tlass.project.gui.panels.SectionPanel;
import tlass.project.model.Section;

public class TestSectionPanel {
	static Controller c;
	static Section s;
	static JTree st;
	static DefaultMutableTreeNode n;
	static MainWindow mw;
	SectionPanel sp;
	
	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		c = new Controller();
		s = new Section();
		st = new JTree();
		n = new DefaultMutableTreeNode();
		mw = new MainWindow(c);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		sp = new SectionPanel(c,s,st,n,mw);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void getSectionTest() {
		assertEquals("Section s is in section panel",s,sp.getSection());
	}
	
	@Test
	public void setSectionTest() {
		Section newS = new Section();
		assertSame("Section s is in section panel",s,sp.getSection());
		assertNotSame("Section newS is not in section panel",newS,sp.getSection());
		sp.setSection(newS);
		assertNotSame("Section s is in section panel",s,sp.getSection());
		assertSame("Section newS is not in section panel",newS,sp.getSection());
	}
}