package tlass.unitTesting.model;

import static org.junit.Assert.*;
import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.constraintTypes.RequireTagsConstraint;
import tlass.project.model.*;
/**
 * 
 * @author AndMac
 *
 */
public class TestModel {
	
	private Model model;
	private Skill skill;
	private Constraint constraint;
	private Schedule schedule;
	private Assistant assistant;
	private Section section;
	private Instructor instructor;
	
	
	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		model = new Model();
		skill = new Skill("a skill");
		constraint = new RequireTagsConstraint();
		schedule = new Schedule();
		assistant = new Assistant();
		section = new Section();
		instructor = new Instructor();
		
		model.addSkill(skill);
		model.addConstraint(constraint);
		model.addSchedule(schedule);
		model.addAssistant(assistant);
		model.addSection(section);
		model.addInstructor(instructor);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		model = null;
		skill = null;
		constraint = null;
		schedule = null;
		assistant = null;
		section = null;
		instructor = null;
		
	}

	/**
	 * tests the model constructor
	 */
	@Test
	public void modelTest() {
		assertNotNull("model constructor failed", model);
	}
	
	/**
	 * Tests the model addSkill method
	 */
	@Test
	public void testAddSkill(){
		assertTrue("addSkill failed for model", model.getSkills().contains(skill));
	}
	
	/**
	 * Tests the model addConstraint method
	 */
	@Test
	public void testAddConstraint(){
		assertTrue("addConstraint failed for model", model.getConstraints().contains(constraint));
	}
	
	/**
	 * Tests the model addSchedule method
	 */
	@Test
	public void testaddSchedule(){
		assertTrue("addSchedule failed for model", model.getSchedules().contains(schedule));
	}

	/**
	 * Tests the model addAssistant method
	 */
	@Test
	public void testAddAssistant(){
		assertTrue("addAssistant failed for model", model.getAssistants().contains(assistant));
	}
	
	/**
	 * Tests the model addSection method
	 */
	@Test
	public void testAddSection(){
		assertTrue("addSection failed for model", model.getSections().contains(section));
	}
	
	/**
	 * Tests the model addInstructor method
	 */
	@Test
	public void testAddInstructor(){
		assertTrue("addInstructor failed for model", model.getInstructors().contains(instructor));
	}
	
	//////remove items:
	
	/**
	 * Tests the model removeSkill method
	 */
	@Test
	public void testremoveSkill(){
		model.removeSkill(skill);
		assertFalse("removeSkill failed for model", model.getSkills().contains(skill));
	}
	
	/**
	 * Tests the model removeSchedule method
	 */
	@Test
	public void testremoveSchedule(){
		model.removeSchedule(schedule);
		assertFalse("removeSchedule failed for model", model.getSchedules().contains(schedule));
	}

	/**
	 * Tests the model removeAssistant method
	 */
	@Test
	public void testremoveAssistant(){
		model.removeAssistant(assistant);
		assertFalse("removeAssistant failed for model", model.getAssistants().contains(assistant));
	}
	
	/**
	 * Tests the model removeSection method
	 */
	@Test
	public void testremoveSection(){
		model.removeSection(section);
		assertFalse("removeSection failed for model", model.getSections().contains(section));
	}
	
	/**
	 * Tests the model removeInstructor method
	 */
	@Test
	public void testremoveInstructor(){
		model.removeInstructor(instructor);
		assertFalse("removeInstructor failed for model", model.getInstructors().contains(instructor));
	}
	
}