package tlass.unitTesting.model;

import static org.junit.Assert.*;


import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.model.Assistant;
import tlass.project.model.Position;
import tlass.project.model.Section;
/**
 * 
 * @author AndMac
 *
 */
public class TestPosition {

	Position position;
	Section section;
	Assistant assistant;
	boolean isTA;
	int order;
	
	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		section = new Section();
		section.setId("1234");
		isTA = true;
		int o = 1;
		assistant = new Assistant();
		position = new Position(section, isTA, o);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		section = null;
		position = null;
		assistant = null;
	}

	/**
	 * Tests the position constructor
	 */
	@Test
	public void positionTest() {
		assertNotNull("position constructor failed", position);
	}

	
	/**
	 * Tests the position name formatted print out
	 */
	@Test
	public void getPositionNameTest() {
		assertEquals("position name failed", position.getPositionName(), "TA #2");
	}
	
	/**
	 * Tests the position toString method
	 */
	@Test
	public void testToString(){
		assertEquals("toString failed for position", position.toString(), "#2");
	}
	
	/**
	 * Tests the position buildId method
	 */
	@Test
	public void testBuildId(){
		assertEquals("buildId failed for position", position.buildId("1234", 1, 100), "1234-ta-100");
	}
}