package tlass.unitTesting.model;

import static org.junit.Assert.*;
import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.model.Response;
/**
 * 
 * @author AndMac
 *
 */
public class TestResponse {

	Response response01, response02;
	
	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		response01 = new Response();
		response01.setComment("Comment01");
		response01.setValue(4); //sets to FINALIZED
		response02 = new Response(true, "Comment02"); //sets to ACCEPTED
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		response01 = null;
		response02 = null;
	}

	/**
	 * Tests the response constructors
	 */
	@Test
	public void testResponse() {
		assertNotNull("response constructor01 failed", response01);
		assertNotNull("response constructor02 failed", response02);
	}

	/**
	 * Tests the response toString method
	 */
	@Test
	public void testToString(){
		assertEquals("toString failed for response01", response01.toString(), "Finalized");
		assertEquals("toString failed for response02", response02.toString(), "Accepted");
	}
	
	/**
	 * Tests the response rest method
	 */
	@Test
	public void testReset(){
		response01.reset();
		assertTrue("reset failed for value", response01.getValue() == 0);
		assertEquals("reset failed for comment", response01.getComment(), "");
	}
	
	/**
	 * Tests the response setFrom method
	 */
	@Test
	public void testSetFrom(){
		response01.setFrom(response02);
		assertTrue("setFrom failed for value", response01.getValue() == response02.getValue());
		assertEquals("setFrom failed for comment", response01.getComment(), response02.getComment());
	}
	
	/**
	 * Tests the response sameAs method
	 */
	@Test
	public void testSameAs(){
		assertFalse("response01 and response02 are the same", response01.sameAs(response02));
		response02.setValue(response01.getValue());
		assertTrue("response01 and response02 are not the same", response01.sameAs(response02));
	}
	
}