package tlass.unitTesting.model;

import static org.junit.Assert.*;
import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.model.Assistant;
import tlass.project.model.Position;
import tlass.project.model.Schedule;
import tlass.project.model.Section;
/**
 * 
 * @author AndMac
 *
 */
public class TestSchedule {

	private Schedule schedule;
	private Assistant assistant;
	private Position position;
	private Section section;
	
	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		schedule = new Schedule();
		schedule.setName("A schedule");
		assistant = new Assistant();
		section = new Section();
		position = new Position(section, true, 1);
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
		schedule = null;
		section = null;
		assistant = null;
		position = null;
	}

	/**
	 * tests the schedule constructor
	 */
	@Test
	public void scheduleTest() {
		assertNotNull("schedule constructor failed", schedule);
	}
	
	/**
	 * Tests the schedule toString method
	 */
	@Test
	public void toStringTest(){
		assertEquals("toString failed for schedule", schedule.toString(), "A schedule");
	}
	
	/**
	 * Tests the schedule addAssignment method
	 */
	@Test
	public void addAssignmentTest(){
		schedule.addAssignment(position, assistant);
		assertEquals("addAssignment failed for schedule", assistant, schedule.getAssignment(position));
	}
	
	/**
	 * Tests the schedule canFinalize method
	 */
	@Test
	public void canFinalizeTest(){
		assertTrue("schedule cannot be finalized", schedule.canFinalize());
	}

	/**
	 * Tests the schedule canPublish method
	 */
	@Test
	public void canPublishTest(){
		assertTrue("schedule cannot be published", schedule.canPublish());
	}
	
}