package tlass.unitTesting.project;

import static org.junit.Assert.*;

import java.util.ArrayList;

import junit.framework.TestCase;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import tlass.project.Scheduler;
import tlass.project.constraintTypes.RequireTagsConstraint;
import tlass.project.model.Assistant;
import tlass.project.model.Constraint;
import tlass.project.model.Model;
import tlass.project.model.Position;
import tlass.project.model.Schedule;
import tlass.project.model.Section;
import tlass.project.model.Skill;

public class TestScheduler {
	
	Scheduler scheduler;
	private Model model;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		scheduler= new Scheduler();
		model= new Model();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}
	
	@Test
	public void pickTest() {
		Assistant a= new Assistant();
		Section s= new Section();
		s.addTAPosition();
		model.addAssistant(a);
		model.addSection(s);
		Schedule c= scheduler.pick(model);
		assertNotNull("A schedule was not generated",c);
		model.removeAssistant(a);
		c= scheduler.pick(model);
		assertNull("A schedule was generated",c);
	}
	
	@Test
	public void diagnoseTest() {
		Assistant a= new Assistant();
		Section s= new Section();
		s.addTAPosition();
		model.addAssistant(a);
		model.addSection(s);
		ArrayList<Position> c= scheduler.findProblemPositions(model);
		assertNotNull("Problems found",c);
		
		Constraint o = new RequireTagsConstraint();
		model.addConstraint(o);
		s.addSkill(new Skill("Anything"));
		c= scheduler.findProblemPositions(model);
		assertTrue("Problems not found",!c.isEmpty());
		
		model.removeAssistant(a);
		c= scheduler.findProblemPositions(model);
		assertNull("Problems not found",c);
	}

}